#error.s - Error handling stuff.

	.include "forth.inc"

	.set n_err_msgs, 3

	cdata

	#messages
misc_err:	emsg "ERR quit."
bs_err:	emsg "Interpreter in invalid state."
eoi_err:	emsg "Unexpected end of input."


	data

	#message pointers
emsgs:	.int bs_err, eoi_err, misc_err


	code

	.global error
error:
	#save error code
	stwu r3,-4(rs)
	#set r3 = offset of error message
	addi r3,r3,-1
	cmpwi r3,n_err_msgs
	ble 0f
	li r3,n_err_msgs-1
0:	slwi r3,r3,2
	#print message
	liw r4,emsgs
	lwzx r4,r4,r3
	lbz r5,0(r4)
	addi r4,r4,1
	bl err_print
	#exit with error code
	lwz r3,0(rs)
	addi rs,rs,4
	b exit
